package com.qmth.exam.reserve.mq;

import com.qmth.exam.reserve.bean.apply.ApplyRecordCacheBean;
import org.apache.rocketmq.client.producer.SendResult;
import org.apache.rocketmq.spring.core.RocketMQTemplate;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Component
public class ExamReserveMQProducer implements MQConstants {

    private static final Logger log = LoggerFactory.getLogger(ExamReserveMQProducer.class);

    @Resource
    private RocketMQTemplate rocketMQTemplate;

    @Value("${rocketmq.topic}")
    private String mqTopic;

    public void sendMessage(ApplyRecordCacheBean message) {
        // 按考点ID分区队列（同个考点下消息按顺序执行）
        String hashKey = String.valueOf(message.getExamSiteId());

        String destination = mqTopic + ":" + TAG_STUDENT_APPLY;
        SendResult result = rocketMQTemplate.syncSendOrderly(destination, message, hashKey);
        log.info("【考生预约队列】消息推送！sendStatus:{} msgId:{} queueOffset:{} {}_{}_{}_{}",
                result.getSendStatus(), result.getMsgId(), result.getQueueOffset(), message.getStudentId(),
                message.getExamSiteId(), message.getTimePeriodId(), message.getCancel());
    }

}
